Status: Closed Start date: 12 Feb 2013

Priority: High Due date:  

Assignee: Anna Maria Bigatti % Done: 100%

Category: Parser/Interpreter Estimated time: 0.00 hour

Target version: CoCoA-5.0.9 Spent time: 2.15 hours

Description

We have many arguments like

...(intrusive_ptr_cast<BigIntValue>(v)->theInteger)...

...(intrusive_ptr_cast<RingElemValue>(v)->theRingElem)...

where v is a intrusive_ptr<RightValue>    

I think we should have a function returning "the actual value".

As I cannot see very far I suggest, at least to start with, one function per type (making it easier to control the types)

instead of a very abstract function (opening the road for a more automatic way of "CoCoA-5 oveloading").

Example:

  RingElem& theRingElem(const intrusive_ptr<RightValue>& v)

  { return intrusive_ptr_cast<RingElemValue>(v)->theRingElem; }

would that work?  any suggestion for a better name?    

AMB 2013-02-13  it works and is called, for the time being, PtrCastRingElem

Related issues:

Related to CoCoA-5 - Design #294: BuiltInFunctions: General "OneLiner" for ar... Closed 23 Jan 2013

History

#1 - 12 Feb 2013 12:07 - Anna Maria Bigatti

- Category set to Parser/Interpreter

- Target version set to CoCoA-5.0.9

#2 - 12 Feb 2013 14:29 - John Abbott

JAA likes the proposal; cannot see any obvious objection (I wonder if the compiler will).

Other possible names: GetRingElem, AsRingElem.

#3 - 13 Feb 2013 08:52 - Anna Maria Bigatti

- Status changed from New to In Progress

- Assignee set to Anna Maria Bigatti

Too many new functions for modules: I think I'd better start experimenting with this "shortcut" ;-)

I'll try the name CastPtrRingElem: easy to find and replace...

But what is the difference between these two?
boost::dynamic_pointer_cast<const RingElemValue>

intrusive_ptr_cast<RingElemValue>

??

#4 - 13 Feb 2013 10:00 - Anna Maria Bigatti

Implemented: seems to work fine.  Example (in BuiltinFunctions.H)

inline const BigInt& PtrCastBigInt(boost::intrusive_ptr<const RightValue> x)

{ return intrusive_ptr_cast<const BigIntValue>(x)->theInteger; }

... I admit I never know when problems with temporaries might arise, but I'm confident that it would crash on my tests if this were the case ;-)

#5 - 15 Feb 2013 17:59 - Anna Maria Bigatti

- Target version changed from CoCoA-5.0.9 to CoCoA-5.0.3

- % Done changed from 0 to 50

#6 - 31 May 2013 09:36 - Anna Maria Bigatti

- Target version changed from CoCoA-5.0.3 to CoCoA-5.0.9

#7 - 03 Mar 2014 19:15 - Anna Maria Bigatti

- Status changed from In Progress to Feedback

- Priority changed from Normal to High

- % Done changed from 50 to 90

I think it looks pretty nice now.  I even wrote a bit of documentation.

Feedback.

#8 - 21 Mar 2014 11:31 - Anna Maria Bigatti

- Status changed from Feedback to Closed

- % Done changed from 90 to 100

No problems have arisen.  Closing.
